#!/bin/sh
export PATH="/usr/kerberos/sbin:/usr/kerberos/bin:/usr/lib64/ccache:/usr/local/bin:/bin:/usr/bin:/home/weimer/bin:/sbin:/usr/sbin"
ulimit -t 20
ulimit -u 200
ulimit -c 0

cd /home/cs415/ || exit 1 
if [ -z "$1" ] ; then 
	echo "No argument given: exiting!" 
	exit 1 
fi 
if [ -s "$1" ] ; then 
	echo "ZIP file: exists ..." 
else 
	echo "ZIP file: not found: exiting!" 
	exit 1 
fi 
export ZIP=$1
export DIR=$1"-dir"
/bin/mkdir "$DIR"
cd "$DIR"
echo "ZIP file: extracting ..." 
unzip -uj ../$ZIP
echo "ZIP file: done ..." 
echo "Checking for main.py / main.rb / main.ml ..." 
if [ -s "main.py" ] ; then 
	USERCMD="python main.py" 
	echo "main.py: found" 
elif [ -s "main.rb" ] ; then 
	USERCMD="ruby main.rb" 
	echo "main.rb: found" 
elif [ -s "main.ml" ] ; then 
	echo "main.ml: found" 
        echo "Compiling: ocamlc unix.cma str.cma *.ml"
	ocamlc unix.cma str.cma *.ml || exit 1 
        echo "Compiled: success" 
	USERCMD="./a.out" 
else 
	echo "Neither main.py nor main.rb nor main.ml found: follow the submission instructions" 
	cd ..
        rm -rf $ZIP $DIR 
	exit 1
fi 
echo "Run command: $USERCMD" 

printf "\n\nPositive Test Cases\n\n" 
for i in `cat /pa5-tests/good/names` ; do 
  cp "/pa5-tests/good/$i.cl-type" .
  cp -f "/pa5-tests/good/$i.INPUT" INPUT
  touch INPUT
  printf "%-40s " "good/$i"
  $USERCMD "$i.cl-type" >& output-me < INPUT
  if diff "output-me" "/pa5-tests/good/$i.OUTPUT" >& /dev/null ; then
    echo "        ok  "
  else 
    if [ -s "output-me" ] ; then 
      echo "      FAILED"
    else 
      echo "      FAILED (empty output)"
    fi 
  fi 
  rm -f *.cl-type output* INPUT
done 

printf "\n\nNegative Test Cases\n\n" 
for i in `cat /pa5-tests/bad/names` ; do 
  cp "/pa5-tests/bad/$i.cl-type" .
  cp -f "/pa5-tests/bad/$i.INPUT" INPUT
  touch INPUT
  printf "%-40s " "bad/$i"
  $USERCMD "$i.cl-type" >& output < INPUT
  cut -d : -f 1-2 output > output-me 
  cut -d : -f 1-2 "/pa5-tests/bad/$i.OUTPUT" > output-you 
  if diff -b -B -E -w output-me output-you >& /dev/null ; then
    echo "        ok  "
  else 
    if [ -s "output-me" ] ; then 
      echo "      FAILED"
    else 
      echo "      FAILED (empty output)"
    fi 
  fi 
  rm -f *.cl-type output* INPUT
done 

cd ../
rm -rf $ZIP $DIR 
